-- Test remove_surroundings_highlight
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(12);

set search_path to camper, public;

select has_function('camper', 'remove_surroundings_highlight', array['integer']);
select function_lang_is('camper', 'remove_surroundings_highlight', array['integer'], 'sql');
select function_returns('camper', 'remove_surroundings_highlight', array['integer'], 'void');
select isnt_definer('camper', 'remove_surroundings_highlight', array['integer']);
select volatility_is('camper', 'remove_surroundings_highlight', array['integer'], 'volatile');
select function_privs_are('camper', 'remove_surroundings_highlight', array['integer'], 'guest', array[]::text[]);
select function_privs_are('camper', 'remove_surroundings_highlight', array['integer'], 'employee', array[]::text[]);
select function_privs_are('camper', 'remove_surroundings_highlight', array['integer'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'remove_surroundings_highlight', array['integer'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate surroundings_highlight cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (3, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , (4, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
;

insert into surroundings_highlight (surroundings_highlight_id, company_id, media_id, name, description)
values (7, 1, 2, 'Highlight A', '<h2>One</h2>')
     , (8, 1, 3, 'Highlight B', '<h2>Two</h2>')
     , (9, 1, 3, 'Highlight C', '<h2>Three</h2>')
;

insert into surroundings_highlight_i18n (surroundings_highlight_id, lang_tag, name, description)
values (7, 'ca', 'Destacat A', '')
     , (7, 'es', 'Destacado A', '')
     , (8, 'ca', 'Destacat B', '')
     , (8, 'es', 'Destacado B', '')
     , (9, 'ca', 'Destacat C', '')
     , (9, 'es', 'Destacado C', '')
;

select lives_ok(
	$$ select remove_surroundings_highlight(8) $$,
	'Should be able to delete a service'
);

select bag_eq(
	$$ select surroundings_highlight_id, name from surroundings_highlight $$,
	$$ values (7, 'Highlight A')
	        , (9, 'Highlight C')
	$$,
	'Should have removed the highlight'
);

select bag_eq(
	$$ select surroundings_highlight_id, lang_tag, name from surroundings_highlight_i18n $$,
	$$ values (7, 'ca', 'Destacat A')
	        , (7, 'es', 'Destacado A')
	        , (9, 'ca', 'Destacat C')
	        , (9, 'es', 'Destacado C')
	$$,
	'Should have removed the highlight’s translations'
);

select *
from finish();

rollback;
